import { AjaxError, BigNumberString, DataWalletAddress, EVMAccountAddress, EVMContractAddress, EVMPrivateKey, HexString, InsightString, IpfsCID, Signature, URLString } from "@snickerdoodlelabs/objects";
import { ResultAsync } from "neverthrow";
export interface IInsightPlatformRepository {
    deliverInsights(dataWalletAddress: DataWalletAddress, consentContractAddress: EVMContractAddress, queryCid: IpfsCID, returns: InsightString[], dataWalletKey: EVMPrivateKey, insightPlatformBaseUrl: URLString): ResultAsync<void, AjaxError>;
    executeMetatransaction(dataWalletAddress: DataWalletAddress, accountAddress: EVMAccountAddress, contractAddress: EVMContractAddress, nonce: BigNumberString, value: BigNumberString, gas: BigNumberString, data: HexString, metatransactionSignature: Signature, dataWalletKey: EVMPrivateKey, insightPlatformBaseUrl: URLString): ResultAsync<void, AjaxError>;
}
export declare const IInsightPlatformRepositoryType: unique symbol;
//# sourceMappingURL=IInsightPlatformRepository.d.ts.map