import { IAxiosAjaxUtils, ICryptoUtils } from "@snickerdoodlelabs/common-utils";
import { AjaxError, IpfsCID, EVMContractAddress, Signature, DataWalletAddress, EVMAccountAddress, HexString, EVMPrivateKey, BigNumberString, InsightString, URLString } from "@snickerdoodlelabs/objects";
import { ResultAsync } from "neverthrow";
import { IInsightPlatformRepository } from "./IInsightPlatformRepository.js";
export declare class InsightPlatformRepository implements IInsightPlatformRepository {
    protected cryptoUtils: ICryptoUtils;
    protected ajaxUtils: IAxiosAjaxUtils;
    constructor(cryptoUtils: ICryptoUtils, ajaxUtils: IAxiosAjaxUtils);
    deliverInsights(dataWalletAddress: DataWalletAddress, consentContractAddress: EVMContractAddress, queryCid: IpfsCID, returns: InsightString[], dataWalletKey: EVMPrivateKey, insightPlatformBaseUrl: URLString): ResultAsync<void, AjaxError>;
    executeMetatransaction(dataWalletAddress: DataWalletAddress, accountAddress: EVMAccountAddress, contractAddress: EVMContractAddress, nonce: BigNumberString, value: BigNumberString, gas: BigNumberString, data: HexString, metatransactionSignature: Signature, dataWalletKey: EVMPrivateKey, insightPlatformBaseUrl: URLString): ResultAsync<void, AjaxError>;
}
//# sourceMappingURL=InsightPlatformRepository.d.ts.map