var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
import { IAxiosAjaxUtilsType, ICryptoUtilsType, } from "@snickerdoodlelabs/common-utils";
import { snickerdoodleSigningDomain, executeMetatransactionTypes, insightDeliveryTypes, } from "@snickerdoodlelabs/signature-verification";
import { inject, injectable } from "inversify";
import { urlJoin } from "url-join-ts";
let InsightPlatformRepository = class InsightPlatformRepository {
    constructor(cryptoUtils, ajaxUtils) {
        this.cryptoUtils = cryptoUtils;
        this.ajaxUtils = ajaxUtils;
    }
    deliverInsights(dataWalletAddress, consentContractAddress, queryCid, returns, dataWalletKey, insightPlatformBaseUrl) {
        const returnsString = JSON.stringify(returns);
        const signableData = {
            consentContractId: consentContractAddress,
            queryCid: queryCid,
            dataWallet: dataWalletAddress,
            returns: returnsString,
        };
        return this.cryptoUtils
            .signTypedData(snickerdoodleSigningDomain, insightDeliveryTypes, signableData, dataWalletKey)
            .andThen((signature) => {
            const url = new URL(urlJoin(insightPlatformBaseUrl, "insights/responses"));
            return this.ajaxUtils.post(url, {
                consentContractId: consentContractAddress,
                queryCid: queryCid,
                dataWallet: dataWalletAddress,
                returns: returns,
                signature: signature,
            });
        })
            .map((response) => {
            console.log("Ajax response: " + JSON.stringify(response));
            // return okAsync({});
        });
    }
    executeMetatransaction(dataWalletAddress, accountAddress, contractAddress, nonce, value, gas, data, metatransactionSignature, dataWalletKey, insightPlatformBaseUrl) {
        const signingData = {
            dataWallet: dataWalletAddress,
            accountAddress: accountAddress,
            contractAddress: contractAddress,
            nonce: nonce,
            data: data,
            metatransactionSignature: metatransactionSignature,
        };
        return this.cryptoUtils
            .signTypedData(snickerdoodleSigningDomain, executeMetatransactionTypes, signingData, dataWalletKey)
            .andThen((signature) => {
            const url = new URL(urlJoin(insightPlatformBaseUrl, "metatransaction"));
            const postBody = {
                dataWalletAddress: dataWalletAddress,
                accountAddress: accountAddress,
                contractAddress: contractAddress,
                nonce: nonce,
                value: value,
                gas: gas,
                data: data,
                metatransactionSignature: metatransactionSignature,
                requestSignature: signature,
            };
            return this.ajaxUtils.post(url, postBody);
        })
            .map(() => { });
    }
};
InsightPlatformRepository = __decorate([
    injectable(),
    __param(0, inject(ICryptoUtilsType)),
    __param(1, inject(IAxiosAjaxUtilsType))
], InsightPlatformRepository);
export { InsightPlatformRepository };
//# sourceMappingURL=InsightPlatformRepository.js.map